document.addEventListener("DOMContentLoaded", function() {

    // access DOM

    const cartBtnDOM = document.getElementById("cart-btn");
    const cartDOM = document.getElementById("cart-ajax-result");
    const cartBodyDOM = document.getElementById("cart-ajax-result-body");

    const addToCartBtnDOM = document.getElementsByClassName("add-to-cart");

    // other property
    let requestLock = false;



    // set handler for DOM

    for (const element of addToCartBtnDOM) {
        element.onclick = toCartFunc;
    }

    cartBtnDOM.onclick = showCartFunc;



    // call require functions

    loadCartFunc();


    // callback dom

    function showCartFunc() {
        const thisElement = this;

        cartDOM.classList.toggle("ds-none");

    }

    function toCartFunc(e) {
        e.preventDefault();
        const thisElement = this;
        const PID = thisElement.dataset['id'];
        const itemAdded = thisElement.dataset['added'];

        if (itemAdded == "false") {


            customGetRequestFunc({
                params: {
                    "pid": PID,
                    "state": "add"
                },
                loadFunc: function() {
                    requestLock = false;
                    const cartItems = this.response;

                    if (cartItems) {
                        if (cartItems['status'] == 1) {
                            loadCartFunc();
                            thisElement.setAttribute("data-added", "true");
                            thisElement.innerHTML = "✅";
                        } else
                            window.alert(cartItems['msg']);
                    }
                }
            });
        } else {
            alert("این محصول از قبل به سبد خرید اضافه شده");
        }

    }

    // ajax request

    function customGetRequestFunc(options) {
        if(requestLock == true)
            return;

        const xhr = new XMLHttpRequest();
        xhr.responseType = "json";

        requestLock = true;

        let queryString = new URLSearchParams;

        const params = options.params;
        for (const param in params) {
            queryString.append(param, params[param]);
        }


        queryString = "?" + queryString.toString();

        xhr.open("GET", location.origin + "/cart.php" + queryString);

        xhr.onload = options.loadFunc;

        xhr.onerror = function() {
            requestLock = false;
            console.warn("[XHR Error]");
        }

        xhr.send();
    }

    function loadCartFunc() {
        customGetRequestFunc({
            params: {
                "rcv": "true"
            },
            loadFunc: function() {
                requestLock = false;
                const cartItems = this.response;

                if (cartItems) {
                    if (cartItems['status'] == 1) {

                        cartBodyDOM.innerHTML = "";

                        if (cartItems['pid_list'] == false)
                            cartBodyDOM.innerHTML = "خالی ):";
                        else {
                            for (const cartItem of cartItems['pid_list']) {
                                const productAddCartBtn = document.getElementById("pid_" + cartItem.id);

                                if (productAddCartBtn) {
                                    productAddCartBtn.innerHTML = "✅";
                                    productAddCartBtn.setAttribute("data-added", "true");
                                }

                                cartBodyDOM.innerHTML += generateHtmlElementFunc(cartItem);
                            }
                        }
                    } else
                        window.alert(cartItems['msg']);
                }
            }
        });
    }


    // other

    window.removeItemFromCartFunc = function(e) {
        const thisElement = e.target;
        const PID = thisElement.getAttribute("data-id");

        customGetRequestFunc({
            params: {
                "pid": PID,
                "state": "rmv"
            },
            loadFunc: function() {
                requestLock = false;
                const cartItems = this.response;

                uniqueAddToCartBtnDOM = document.getElementById("pid_" + PID);



                if (cartItems) {
                    if (cartItems['status'] == 1) {
                        if (uniqueAddToCartBtnDOM) {
                            uniqueAddToCartBtnDOM.setAttribute("data-added", "false");
                            uniqueAddToCartBtnDOM.innerHTML = "افزودن به سبد خرید";
                        }
                        loadCartFunc();
                    } else
                        window.alert("خطایی رخ داده")
                }
            }
        });

    }

    function generateHtmlElementFunc(data) {
        const templateHtml = `<tr data-ID="${data.id}"><td><img src="${data.thumbnail}" alt="${data.title}"></td><td><h2>${data.title}</h2><br><span id="price">${data.price} تومان</span></td><td><span class="remove-from-cart" onclick="removeItemFromCartFunc(event)" data-id="${data.id}">✘</span></td></tr>`;
        return templateHtml;
    }



});